EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_POSITION_MANAGER_ENTITY_EVENT_CONTENT_SIZE_CHANGED =
   EFL_EVENT_DESCRIPTION("content_size,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_POSITION_MANAGER_ENTITY_EVENT_CONTENT_MIN_SIZE_CHANGED =
   EFL_EVENT_DESCRIPTION("content_min_size,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_POSITION_MANAGER_ENTITY_EVENT_VISIBLE_RANGE_CHANGED =
   EFL_EVENT_DESCRIPTION("visible_range,changed");
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_position_manager_entity_version, int, 0, EFL_FUNC_CALL(max), int max);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_viewport_set, EFL_FUNC_CALL(viewport), Eina_Rect viewport);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_scroll_position_set, EFL_FUNC_CALL(x, y), double x, double y);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_position_manager_entity_position_single_item, Eina_Rect, (EINA_RECT_EMPTY()), EFL_FUNC_CALL(idx), int idx);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_item_added, EFL_FUNC_CALL(added_index, subobj), int added_index, Efl_Gfx_Entity *subobj);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_item_removed, EFL_FUNC_CALL(removed_index, subobj), int removed_index, Efl_Gfx_Entity *subobj);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_item_size_changed, EFL_FUNC_CALL(start_id, end_id), int start_id, int end_id);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_position_manager_entity_entities_ready, EFL_FUNC_CALL(start_id, end_id), unsigned int start_id, unsigned int end_id);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_position_manager_entity_relative_item, Eina_Bool, 0, EFL_FUNC_CALL(current_id, direction, index), unsigned int current_id, Efl_Ui_Focus_Direction direction, unsigned int *index);

static Eina_Bool
_efl_ui_position_manager_entity_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_POSITION_MANAGER_ENTITY_EXTRA_OPS
#define EFL_UI_POSITION_MANAGER_ENTITY_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_version, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_viewport_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_scroll_position_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_position_single_item, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_item_added, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_item_removed, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_item_size_changed, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_entities_ready, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_position_manager_entity_relative_item, NULL),
      EFL_UI_POSITION_MANAGER_ENTITY_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_position_manager_entity_class_desc = {
   EO_VERSION,
   "Efl.Ui.Position_Manager.Entity",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_ui_position_manager_entity_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_position_manager_entity_interface_get, &_efl_ui_position_manager_entity_class_desc, NULL, EFL_UI_LAYOUT_ORIENTABLE_INTERFACE, NULL);
